package physicssim;
import com.interworldtransport.clados.*;
import java.applet.*;
import java.awt.*;
import java.util.Timer;

/**
 * <p>Title: physicssim (can you think of a better name?)</p>
 * <p>Description: A physics simulator using clados</p>
 * <p>Copyright: GNU General Public License.  A full copy of the license can be found bundled with this package.
 * <p>Company: </p>
 * @author Martin Baker and Alfred Differ
 * @version 1.0
 */

public class global extends Applet implements Runnable{
shape[] shapes;
force[] forces;
long timestamp,lastTimestamp;
// Timer Event
static int r = 10;
Rectangle screen;
//Timer timer = new Timer(false); // Create Timer

  public global() {
//    lastTimestamp = System.currentTimeMillis();
     shapes = new shape[2];
     shapes[0] = new box();
     shapes[1] = new sphere();
  }

  /**
   * Called by the browser or applet viewer to inform this applet that it
   * has been loaded into the system. It is always called before the first
   * time that the start method is called.
   * we override this method if it has initialization to perform. For
   * example, an applet with threads would use the init method to create
   * the threads and the destroy method to kill them.
   */
  public void init() {
          resize(800,600); // Set Screen size
          run(); // Run Scheduler
  }

  /** implemetation of runable interface
   * called by thread.start
   */
  public void run() {
      repaint();
      Thread thread=new Thread(this);
      thread.start();
  }
/*          class Refresh extends java.util.TimerTask {	// Create repaint event
                  public void run(){repaint();}
          }
          timer.schedule(new Refresh(),0,r);			// Schedule repaint
  }*/


  /** Called by the browser or applet viewer to inform this applet that it
   *  should start its execution. It is called after the init method and each
   * time the applet is revisited in a Web page.
   * we override this method if it has any operation that it wants to perform
   * each time the Web page containing it is visited. For example, an applet
   * with animation might want to use the start method to resume animation,
   * and the stop method to suspend the animation.
   */
  public void start() {
//     timer = new Timer(false);
     run();
  }

  /**
   * Called by the browser or applet viewer to inform this applet that it
   * should stop its execution. It is called when the Web page that contains
   * this applet has been replaced by another page, and also just before the
   * applet is to be destroyed.
   * we override this method if it has any operation that it wants to perform
   * each time the Web page containing it is no longer visible. For example,
   * an applet with animation might want to use the start method to resume
   * animation, and the stop method to suspend the animation.
   */
  public void stop() {
        //  timer.cancel();
  }

  /**
   * Called by the browser or applet viewer to inform this applet that it
   * is being reclaimed and that it should destroy any resources that it
   * has allocated. The stop method will always be called before destroy.
   * we override this method if it has any operation that it wants to
   * perform before it is destroyed. For example, an applet with threads
   * would use the init method to create the threads and the destroy method
   * to kill them.
   */
  public void destroy() {

  }

  //Get Applet information
  public String getAppletInfo() {
    return "physics simulator program";
  }

  //Get parameter info
/*  public String[][] getParameterInfo() {
    String[][] params = {{"hello","p1","p1"}};
    return params;
  }*/

  public void update() {
         int height, width;				// Screen Parameters

          screen = getBounds();			// Get Screen size
          height =(int)screen.getHeight();// Set height
          width = (int)screen.getWidth();	// Set width


  }

public void paint(Graphics g) {
//  int x1=0;
//  int y1=0;
//  int x2=40;
//  int y2=40;
//  g.drawLine(x1,y1,x2,y2);
//         update();					// Update
         g.setColor(Color.black);	// Line Black
         for (int i=0;i<shapes.length;i++){
           shapes[i].paint(g);
         }
    }

    /** called by render loop prior to rendering next frame
      * this updates the status (location and velocity) of all shapes
      * It is clunky, but it demonstrates the technique.
      */
     public void step() {
       //assumes the existance of a shapes array for all objects in the simulation.
       timestamp = System.currentTimeMillis();
       for (int i=0;i<shapes.length;i++) {
         shapes[i].step(shapes, timestamp-lastTimestamp);
       }
       lastTimestamp = timestamp;
  }

  /** called by render loop prior to rendering next frame
   * this updates the status (location and velocity) of each shape

  public void step(){
    int i;
//    timestamp = System.currentTimeMillis();
    for (i=0;i<shapes.length;i++){
      shapes[i].step(timestamp-lastTimestamp);
    }
    for (i=0;i<shapes.length;i++){
      // simple case for bouncing ball
//      if (shapes[i].intersection()) shapes[i].collisionResponse(null);
       more general case for phase 2
      for (int j=0;j<shapes.length;j++){
        if (i==j) continue;
        if (shapes[i].intersection(shapes[j])) {
           // calculate impulse
           // apply impulse to both shapes
           // shapes[i].collisionResponse(impulse);
           // shapes[j].collisionResponse(-impulse);
        }
      }
    }
    lastTimestamp = timestamp;
  }*/

/** return the net linear force acting on centre of mass of this shape
 */
public Monad sumForces(shape thisShape){
  Monad result=null;
  for (int i=0;i<forces.length;i++){
/*    if (forces[i].s1 == thisShape) {
      result += forces[i].calcForce();
    }
    else if (forces[i].s2 == thisShape) {
      result -= forces[i].calcForce();
    }*/
  }
  return result;
}

/** return the net linear torgue acting about centre of mass of this shape
 */
public Monad sumTorques(shape thisShape){
  return null;
}

}